/*
 * Copyright (C) 2015 Greenstone Digital Library, University of Waikato
 * $Id$
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.greenstone.tdbjava;

import java.util.Enumeration;
import java.util.NoSuchElementException;

import org.greenstone.tdbjava.TDBJava;
import org.greenstone.tdbjava.TDBJavaException;

class TDBJavaKeyEnumeration
    implements Enumeration
{
    private TDBJava db_driver;
    private String current_key;
    private String next_key;

    TDBJavaKeyEnumeration(TDBJava db_driver)
	throws TDBJavaException
    {
	this.db_driver = db_driver;
	this.current_key = null;
	this.next_key = this.db_driver.getFirstKey();
    }

    public boolean hasMoreElements()
    {
	return (this.next_key != null);
    }

    public Object nextElement()
	throws NoSuchElementException
    {
	try {
	    this.current_key = this.next_key;
	    if (this.current_key == null) {
		throw new NoSuchElementException();
	    }
	    else {
		this.next_key = this.db_driver.getNextKey(this.current_key);
	    }
	}
	catch (Exception e) {
	    throw new NoSuchElementException();
	}
        return this.current_key;
    }
}
