/**
 * Copyright (C) 2015 Greenstone Digital Libraries, University of Waikato
 * $Id$
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.greenstone.tdbjava;

import java.lang.Thread;

import org.greenstone.tdbjava.TDBJava;

/** @class TDBJavaShutdownThread
 *  @brief A shutdown hook thread to ensure the database is closed
 */
public class TDBJavaShutdownThread
    extends Thread
{
    protected TDBJava db_driver;

    public TDBJavaShutdownThread(TDBJava db_driver)
    {
	this.db_driver = db_driver;
    }

    public void run()
    {
	try {
	    this.db_driver.close();
	}
	catch (TDBJavaException e) {
	    System.err.println("Failed to cleanly close TDB connection");
	}
    }
}
